import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiManagementBackendConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#api_management_name ApiManagementBackend#api_management_name}.
     *
     * @stability stable
     */
    readonly apiManagementName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#description ApiManagementBackend#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#name ApiManagementBackend#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#protocol ApiManagementBackend#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#resource_group_name ApiManagementBackend#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#resource_id ApiManagementBackend#resource_id}.
     *
     * @stability stable
     */
    readonly resourceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#title ApiManagementBackend#title}.
     *
     * @stability stable
     */
    readonly title?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#url ApiManagementBackend#url}.
     *
     * @stability stable
     */
    readonly url: string;
    /**
     * credentials block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#credentials ApiManagementBackend#credentials}
     *
     * @stability stable
     */
    readonly credentials?: ApiManagementBackendCredentials;
    /**
     * proxy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#proxy ApiManagementBackend#proxy}
     *
     * @stability stable
     */
    readonly proxy?: ApiManagementBackendProxy;
    /**
     * service_fabric_cluster block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#service_fabric_cluster ApiManagementBackend#service_fabric_cluster}
     *
     * @stability stable
     */
    readonly serviceFabricCluster?: ApiManagementBackendServiceFabricCluster;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#timeouts ApiManagementBackend#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ApiManagementBackendTimeouts;
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#tls ApiManagementBackend#tls}
     *
     * @stability stable
     */
    readonly tls?: ApiManagementBackendTls;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendCredentialsAuthorization {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#parameter ApiManagementBackend#parameter}.
     *
     * @stability stable
     */
    readonly parameter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#scheme ApiManagementBackend#scheme}.
     *
     * @stability stable
     */
    readonly scheme?: string;
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendCredentialsAuthorizationOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _parameter?;
    /**
     * @stability stable
     */
    get parameter(): string | undefined;
    /**
     * @stability stable
     */
    set parameter(value: string | undefined);
    /**
     * @stability stable
     */
    resetParameter(): void;
    /**
     * @stability stable
     */
    get parameterInput(): string | undefined;
    private _scheme?;
    /**
     * @stability stable
     */
    get scheme(): string | undefined;
    /**
     * @stability stable
     */
    set scheme(value: string | undefined);
    /**
     * @stability stable
     */
    resetScheme(): void;
    /**
     * @stability stable
     */
    get schemeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendCredentials {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#certificate ApiManagementBackend#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#header ApiManagementBackend#header}.
     *
     * @stability stable
     */
    readonly header?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#query ApiManagementBackend#query}.
     *
     * @stability stable
     */
    readonly query?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * authorization block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#authorization ApiManagementBackend#authorization}
     *
     * @stability stable
     */
    readonly authorization?: ApiManagementBackendCredentialsAuthorization;
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendCredentialsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _certificate?;
    /**
     * @stability stable
     */
    get certificate(): string[] | undefined;
    /**
     * @stability stable
     */
    set certificate(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): string[] | undefined;
    private _header?;
    /**
     * @stability stable
     */
    get header(): {
        [key: string]: string;
    } | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set header(value: {
        [key: string]: string;
    } | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetHeader(): void;
    /**
     * @stability stable
     */
    get headerInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _query?;
    /**
     * @stability stable
     */
    get query(): {
        [key: string]: string;
    } | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set query(value: {
        [key: string]: string;
    } | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetQuery(): void;
    /**
     * @stability stable
     */
    get queryInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _authorization?;
    private __authorizationOutput;
    /**
     * @stability stable
     */
    get authorization(): ApiManagementBackendCredentialsAuthorizationOutputReference;
    /**
     * @stability stable
     */
    putAuthorization(value: ApiManagementBackendCredentialsAuthorization | undefined): void;
    /**
     * @stability stable
     */
    resetAuthorization(): void;
    /**
     * @stability stable
     */
    get authorizationInput(): ApiManagementBackendCredentialsAuthorization | undefined;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendProxy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#password ApiManagementBackend#password}.
     *
     * @stability stable
     */
    readonly password?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#url ApiManagementBackend#url}.
     *
     * @stability stable
     */
    readonly url: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#username ApiManagementBackend#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendProxyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _password?;
    /**
     * @stability stable
     */
    get password(): string | undefined;
    /**
     * @stability stable
     */
    set password(value: string | undefined);
    /**
     * @stability stable
     */
    resetPassword(): void;
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _url?;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    set url(value: string);
    /**
     * @stability stable
     */
    get urlInput(): string | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendServiceFabricClusterServerX509Name {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#issuer_certificate_thumbprint ApiManagementBackend#issuer_certificate_thumbprint}.
     *
     * @stability stable
     */
    readonly issuerCertificateThumbprint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#name ApiManagementBackend#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendServiceFabricCluster {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#client_certificate_id ApiManagementBackend#client_certificate_id}.
     *
     * @stability stable
     */
    readonly clientCertificateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#client_certificate_thumbprint ApiManagementBackend#client_certificate_thumbprint}.
     *
     * @stability stable
     */
    readonly clientCertificateThumbprint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#management_endpoints ApiManagementBackend#management_endpoints}.
     *
     * @stability stable
     */
    readonly managementEndpoints: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#max_partition_resolution_retries ApiManagementBackend#max_partition_resolution_retries}.
     *
     * @stability stable
     */
    readonly maxPartitionResolutionRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#server_certificate_thumbprints ApiManagementBackend#server_certificate_thumbprints}.
     *
     * @stability stable
     */
    readonly serverCertificateThumbprints?: string[];
    /**
     * server_x509_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#server_x509_name ApiManagementBackend#server_x509_name}
     *
     * @stability stable
     */
    readonly serverX509Name?: ApiManagementBackendServiceFabricClusterServerX509Name[];
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendServiceFabricClusterOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _clientCertificateId?;
    /**
     * @stability stable
     */
    get clientCertificateId(): string | undefined;
    /**
     * @stability stable
     */
    set clientCertificateId(value: string | undefined);
    /**
     * @stability stable
     */
    resetClientCertificateId(): void;
    /**
     * @stability stable
     */
    get clientCertificateIdInput(): string | undefined;
    private _clientCertificateThumbprint?;
    /**
     * @stability stable
     */
    get clientCertificateThumbprint(): string | undefined;
    /**
     * @stability stable
     */
    set clientCertificateThumbprint(value: string | undefined);
    /**
     * @stability stable
     */
    resetClientCertificateThumbprint(): void;
    /**
     * @stability stable
     */
    get clientCertificateThumbprintInput(): string | undefined;
    private _managementEndpoints?;
    /**
     * @stability stable
     */
    get managementEndpoints(): string[];
    /**
     * @stability stable
     */
    set managementEndpoints(value: string[]);
    /**
     * @stability stable
     */
    get managementEndpointsInput(): string[] | undefined;
    private _maxPartitionResolutionRetries?;
    /**
     * @stability stable
     */
    get maxPartitionResolutionRetries(): number;
    /**
     * @stability stable
     */
    set maxPartitionResolutionRetries(value: number);
    /**
     * @stability stable
     */
    get maxPartitionResolutionRetriesInput(): number | undefined;
    private _serverCertificateThumbprints?;
    /**
     * @stability stable
     */
    get serverCertificateThumbprints(): string[] | undefined;
    /**
     * @stability stable
     */
    set serverCertificateThumbprints(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetServerCertificateThumbprints(): void;
    /**
     * @stability stable
     */
    get serverCertificateThumbprintsInput(): string[] | undefined;
    private _serverX509Name?;
    /**
     * @stability stable
     */
    get serverX509Name(): ApiManagementBackendServiceFabricClusterServerX509Name[] | undefined;
    /**
     * @stability stable
     */
    set serverX509Name(value: ApiManagementBackendServiceFabricClusterServerX509Name[] | undefined);
    /**
     * @stability stable
     */
    resetServerX509Name(): void;
    /**
     * @stability stable
     */
    get serverX509NameInput(): ApiManagementBackendServiceFabricClusterServerX509Name[] | undefined;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#create ApiManagementBackend#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#delete ApiManagementBackend#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#read ApiManagementBackend#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#update ApiManagementBackend#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ApiManagementBackendTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#validate_certificate_chain ApiManagementBackend#validate_certificate_chain}.
     *
     * @stability stable
     */
    readonly validateCertificateChain?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html#validate_certificate_name ApiManagementBackend#validate_certificate_name}.
     *
     * @stability stable
     */
    readonly validateCertificateName?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class ApiManagementBackendTlsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _validateCertificateChain?;
    /**
     * @stability stable
     */
    get validateCertificateChain(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set validateCertificateChain(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetValidateCertificateChain(): void;
    /**
     * @stability stable
     */
    get validateCertificateChainInput(): boolean | cdktf.IResolvable | undefined;
    private _validateCertificateName?;
    /**
     * @stability stable
     */
    get validateCertificateName(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set validateCertificateName(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetValidateCertificateName(): void;
    /**
     * @stability stable
     */
    get validateCertificateNameInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html azurerm_api_management_backend}.
 *
 * @stability stable
 */
export declare class ApiManagementBackend extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/api_management_backend.html azurerm_api_management_backend} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiManagementBackendConfig);
    private _apiManagementName?;
    /**
     * @stability stable
     */
    get apiManagementName(): string;
    /**
     * @stability stable
     */
    set apiManagementName(value: string);
    /**
     * @stability stable
     */
    get apiManagementNameInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string | undefined;
    /**
     * @stability stable
     */
    set description(value: string | undefined);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _resourceGroupName?;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string | undefined;
    private _resourceId?;
    /**
     * @stability stable
     */
    get resourceId(): string | undefined;
    /**
     * @stability stable
     */
    set resourceId(value: string | undefined);
    /**
     * @stability stable
     */
    resetResourceId(): void;
    /**
     * @stability stable
     */
    get resourceIdInput(): string | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): string | undefined;
    /**
     * @stability stable
     */
    set title(value: string | undefined);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): string | undefined;
    private _url?;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    set url(value: string);
    /**
     * @stability stable
     */
    get urlInput(): string | undefined;
    private _credentials?;
    private __credentialsOutput;
    /**
     * @stability stable
     */
    get credentials(): ApiManagementBackendCredentialsOutputReference;
    /**
     * @stability stable
     */
    putCredentials(value: ApiManagementBackendCredentials | undefined): void;
    /**
     * @stability stable
     */
    resetCredentials(): void;
    /**
     * @stability stable
     */
    get credentialsInput(): ApiManagementBackendCredentials | undefined;
    private _proxy?;
    private __proxyOutput;
    /**
     * @stability stable
     */
    get proxy(): ApiManagementBackendProxyOutputReference;
    /**
     * @stability stable
     */
    putProxy(value: ApiManagementBackendProxy | undefined): void;
    /**
     * @stability stable
     */
    resetProxy(): void;
    /**
     * @stability stable
     */
    get proxyInput(): ApiManagementBackendProxy | undefined;
    private _serviceFabricCluster?;
    private __serviceFabricClusterOutput;
    /**
     * @stability stable
     */
    get serviceFabricCluster(): ApiManagementBackendServiceFabricClusterOutputReference;
    /**
     * @stability stable
     */
    putServiceFabricCluster(value: ApiManagementBackendServiceFabricCluster | undefined): void;
    /**
     * @stability stable
     */
    resetServiceFabricCluster(): void;
    /**
     * @stability stable
     */
    get serviceFabricClusterInput(): ApiManagementBackendServiceFabricCluster | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): ApiManagementBackendTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ApiManagementBackendTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ApiManagementBackendTimeouts | undefined;
    private _tls?;
    private __tlsOutput;
    /**
     * @stability stable
     */
    get tls(): ApiManagementBackendTlsOutputReference;
    /**
     * @stability stable
     */
    putTls(value: ApiManagementBackendTls | undefined): void;
    /**
     * @stability stable
     */
    resetTls(): void;
    /**
     * @stability stable
     */
    get tlsInput(): ApiManagementBackendTls | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
