import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatabricksWorkspaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#customer_managed_key_enabled DatabricksWorkspace#customer_managed_key_enabled}.
     *
     * @stability stable
     */
    readonly customerManagedKeyEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#infrastructure_encryption_enabled DatabricksWorkspace#infrastructure_encryption_enabled}.
     *
     * @stability stable
     */
    readonly infrastructureEncryptionEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#load_balancer_backend_address_pool_id DatabricksWorkspace#load_balancer_backend_address_pool_id}.
     *
     * @stability stable
     */
    readonly loadBalancerBackendAddressPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#location DatabricksWorkspace#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#managed_resource_group_name DatabricksWorkspace#managed_resource_group_name}.
     *
     * @stability stable
     */
    readonly managedResourceGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#managed_services_cmk_key_vault_key_id DatabricksWorkspace#managed_services_cmk_key_vault_key_id}.
     *
     * @stability stable
     */
    readonly managedServicesCmkKeyVaultKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#name DatabricksWorkspace#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#network_security_group_rules_required DatabricksWorkspace#network_security_group_rules_required}.
     *
     * @stability stable
     */
    readonly networkSecurityGroupRulesRequired?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#public_network_access_enabled DatabricksWorkspace#public_network_access_enabled}.
     *
     * @stability stable
     */
    readonly publicNetworkAccessEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#resource_group_name DatabricksWorkspace#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#sku DatabricksWorkspace#sku}.
     *
     * @stability stable
     */
    readonly sku: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#tags DatabricksWorkspace#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * custom_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#custom_parameters DatabricksWorkspace#custom_parameters}
     *
     * @stability stable
     */
    readonly customParameters?: DatabricksWorkspaceCustomParameters;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#timeouts DatabricksWorkspace#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DatabricksWorkspaceTimeouts;
}
/**
 * @stability stable
 */
export declare class DatabricksWorkspaceStorageAccountIdentity extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get principalId(): string;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export interface DatabricksWorkspaceCustomParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#machine_learning_workspace_id DatabricksWorkspace#machine_learning_workspace_id}.
     *
     * @stability stable
     */
    readonly machineLearningWorkspaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#nat_gateway_name DatabricksWorkspace#nat_gateway_name}.
     *
     * @stability stable
     */
    readonly natGatewayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#no_public_ip DatabricksWorkspace#no_public_ip}.
     *
     * @stability stable
     */
    readonly noPublicIp?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#private_subnet_name DatabricksWorkspace#private_subnet_name}.
     *
     * @stability stable
     */
    readonly privateSubnetName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#private_subnet_network_security_group_association_id DatabricksWorkspace#private_subnet_network_security_group_association_id}.
     *
     * @stability stable
     */
    readonly privateSubnetNetworkSecurityGroupAssociationId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#public_ip_name DatabricksWorkspace#public_ip_name}.
     *
     * @stability stable
     */
    readonly publicIpName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#public_subnet_name DatabricksWorkspace#public_subnet_name}.
     *
     * @stability stable
     */
    readonly publicSubnetName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#public_subnet_network_security_group_association_id DatabricksWorkspace#public_subnet_network_security_group_association_id}.
     *
     * @stability stable
     */
    readonly publicSubnetNetworkSecurityGroupAssociationId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#storage_account_name DatabricksWorkspace#storage_account_name}.
     *
     * @stability stable
     */
    readonly storageAccountName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#storage_account_sku_name DatabricksWorkspace#storage_account_sku_name}.
     *
     * @stability stable
     */
    readonly storageAccountSkuName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#virtual_network_id DatabricksWorkspace#virtual_network_id}.
     *
     * @stability stable
     */
    readonly virtualNetworkId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#vnet_address_prefix DatabricksWorkspace#vnet_address_prefix}.
     *
     * @stability stable
     */
    readonly vnetAddressPrefix?: string;
}
/**
 * @stability stable
 */
export declare class DatabricksWorkspaceCustomParametersOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _machineLearningWorkspaceId?;
    /**
     * @stability stable
     */
    get machineLearningWorkspaceId(): string | undefined;
    /**
     * @stability stable
     */
    set machineLearningWorkspaceId(value: string | undefined);
    /**
     * @stability stable
     */
    resetMachineLearningWorkspaceId(): void;
    /**
     * @stability stable
     */
    get machineLearningWorkspaceIdInput(): string | undefined;
    private _natGatewayName?;
    /**
     * @stability stable
     */
    get natGatewayName(): string | undefined;
    /**
     * @stability stable
     */
    set natGatewayName(value: string | undefined);
    /**
     * @stability stable
     */
    resetNatGatewayName(): void;
    /**
     * @stability stable
     */
    get natGatewayNameInput(): string | undefined;
    private _noPublicIp?;
    /**
     * @stability stable
     */
    get noPublicIp(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set noPublicIp(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetNoPublicIp(): void;
    /**
     * @stability stable
     */
    get noPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _privateSubnetName?;
    /**
     * @stability stable
     */
    get privateSubnetName(): string | undefined;
    /**
     * @stability stable
     */
    set privateSubnetName(value: string | undefined);
    /**
     * @stability stable
     */
    resetPrivateSubnetName(): void;
    /**
     * @stability stable
     */
    get privateSubnetNameInput(): string | undefined;
    private _privateSubnetNetworkSecurityGroupAssociationId?;
    /**
     * @stability stable
     */
    get privateSubnetNetworkSecurityGroupAssociationId(): string | undefined;
    /**
     * @stability stable
     */
    set privateSubnetNetworkSecurityGroupAssociationId(value: string | undefined);
    /**
     * @stability stable
     */
    resetPrivateSubnetNetworkSecurityGroupAssociationId(): void;
    /**
     * @stability stable
     */
    get privateSubnetNetworkSecurityGroupAssociationIdInput(): string | undefined;
    private _publicIpName?;
    /**
     * @stability stable
     */
    get publicIpName(): string | undefined;
    /**
     * @stability stable
     */
    set publicIpName(value: string | undefined);
    /**
     * @stability stable
     */
    resetPublicIpName(): void;
    /**
     * @stability stable
     */
    get publicIpNameInput(): string | undefined;
    private _publicSubnetName?;
    /**
     * @stability stable
     */
    get publicSubnetName(): string | undefined;
    /**
     * @stability stable
     */
    set publicSubnetName(value: string | undefined);
    /**
     * @stability stable
     */
    resetPublicSubnetName(): void;
    /**
     * @stability stable
     */
    get publicSubnetNameInput(): string | undefined;
    private _publicSubnetNetworkSecurityGroupAssociationId?;
    /**
     * @stability stable
     */
    get publicSubnetNetworkSecurityGroupAssociationId(): string | undefined;
    /**
     * @stability stable
     */
    set publicSubnetNetworkSecurityGroupAssociationId(value: string | undefined);
    /**
     * @stability stable
     */
    resetPublicSubnetNetworkSecurityGroupAssociationId(): void;
    /**
     * @stability stable
     */
    get publicSubnetNetworkSecurityGroupAssociationIdInput(): string | undefined;
    private _storageAccountName?;
    /**
     * @stability stable
     */
    get storageAccountName(): string | undefined;
    /**
     * @stability stable
     */
    set storageAccountName(value: string | undefined);
    /**
     * @stability stable
     */
    resetStorageAccountName(): void;
    /**
     * @stability stable
     */
    get storageAccountNameInput(): string | undefined;
    private _storageAccountSkuName?;
    /**
     * @stability stable
     */
    get storageAccountSkuName(): string | undefined;
    /**
     * @stability stable
     */
    set storageAccountSkuName(value: string | undefined);
    /**
     * @stability stable
     */
    resetStorageAccountSkuName(): void;
    /**
     * @stability stable
     */
    get storageAccountSkuNameInput(): string | undefined;
    private _virtualNetworkId?;
    /**
     * @stability stable
     */
    get virtualNetworkId(): string | undefined;
    /**
     * @stability stable
     */
    set virtualNetworkId(value: string | undefined);
    /**
     * @stability stable
     */
    resetVirtualNetworkId(): void;
    /**
     * @stability stable
     */
    get virtualNetworkIdInput(): string | undefined;
    private _vnetAddressPrefix?;
    /**
     * @stability stable
     */
    get vnetAddressPrefix(): string | undefined;
    /**
     * @stability stable
     */
    set vnetAddressPrefix(value: string | undefined);
    /**
     * @stability stable
     */
    resetVnetAddressPrefix(): void;
    /**
     * @stability stable
     */
    get vnetAddressPrefixInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface DatabricksWorkspaceTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#create DatabricksWorkspace#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#delete DatabricksWorkspace#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#read DatabricksWorkspace#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html#update DatabricksWorkspace#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DatabricksWorkspaceTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html azurerm_databricks_workspace}.
 *
 * @stability stable
 */
export declare class DatabricksWorkspace extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/databricks_workspace.html azurerm_databricks_workspace} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatabricksWorkspaceConfig);
    private _customerManagedKeyEnabled?;
    /**
     * @stability stable
     */
    get customerManagedKeyEnabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set customerManagedKeyEnabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetCustomerManagedKeyEnabled(): void;
    /**
     * @stability stable
     */
    get customerManagedKeyEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _infrastructureEncryptionEnabled?;
    /**
     * @stability stable
     */
    get infrastructureEncryptionEnabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set infrastructureEncryptionEnabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetInfrastructureEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get infrastructureEncryptionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _loadBalancerBackendAddressPoolId?;
    /**
     * @stability stable
     */
    get loadBalancerBackendAddressPoolId(): string | undefined;
    /**
     * @stability stable
     */
    set loadBalancerBackendAddressPoolId(value: string | undefined);
    /**
     * @stability stable
     */
    resetLoadBalancerBackendAddressPoolId(): void;
    /**
     * @stability stable
     */
    get loadBalancerBackendAddressPoolIdInput(): string | undefined;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    /**
     * @stability stable
     */
    get managedResourceGroupId(): string;
    private _managedResourceGroupName?;
    /**
     * @stability stable
     */
    get managedResourceGroupName(): string | undefined;
    /**
     * @stability stable
     */
    set managedResourceGroupName(value: string | undefined);
    /**
     * @stability stable
     */
    resetManagedResourceGroupName(): void;
    /**
     * @stability stable
     */
    get managedResourceGroupNameInput(): string | undefined;
    private _managedServicesCmkKeyVaultKeyId?;
    /**
     * @stability stable
     */
    get managedServicesCmkKeyVaultKeyId(): string | undefined;
    /**
     * @stability stable
     */
    set managedServicesCmkKeyVaultKeyId(value: string | undefined);
    /**
     * @stability stable
     */
    resetManagedServicesCmkKeyVaultKeyId(): void;
    /**
     * @stability stable
     */
    get managedServicesCmkKeyVaultKeyIdInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _networkSecurityGroupRulesRequired?;
    /**
     * @stability stable
     */
    get networkSecurityGroupRulesRequired(): string | undefined;
    /**
     * @stability stable
     */
    set networkSecurityGroupRulesRequired(value: string | undefined);
    /**
     * @stability stable
     */
    resetNetworkSecurityGroupRulesRequired(): void;
    /**
     * @stability stable
     */
    get networkSecurityGroupRulesRequiredInput(): string | undefined;
    private _publicNetworkAccessEnabled?;
    /**
     * @stability stable
     */
    get publicNetworkAccessEnabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set publicNetworkAccessEnabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetPublicNetworkAccessEnabled(): void;
    /**
     * @stability stable
     */
    get publicNetworkAccessEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _resourceGroupName?;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string | undefined;
    private _sku?;
    /**
     * @stability stable
     */
    get sku(): string;
    /**
     * @stability stable
     */
    set sku(value: string);
    /**
     * @stability stable
     */
    get skuInput(): string | undefined;
    /**
     * @stability stable
     */
    storageAccountIdentity(index: string): DatabricksWorkspaceStorageAccountIdentity;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get workspaceId(): string;
    /**
     * @stability stable
     */
    get workspaceUrl(): string;
    private _customParameters?;
    private __customParametersOutput;
    /**
     * @stability stable
     */
    get customParameters(): DatabricksWorkspaceCustomParametersOutputReference;
    /**
     * @stability stable
     */
    putCustomParameters(value: DatabricksWorkspaceCustomParameters | undefined): void;
    /**
     * @stability stable
     */
    resetCustomParameters(): void;
    /**
     * @stability stable
     */
    get customParametersInput(): DatabricksWorkspaceCustomParameters | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): DatabricksWorkspaceTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: DatabricksWorkspaceTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DatabricksWorkspaceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
