import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#firewall_policy_id FirewallPolicyRuleCollectionGroup#firewall_policy_id}.
     *
     * @stability stable
     */
    readonly firewallPolicyId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#priority FirewallPolicyRuleCollectionGroup#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
    /**
     * application_rule_collection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#application_rule_collection FirewallPolicyRuleCollectionGroup#application_rule_collection}
     *
     * @stability stable
     */
    readonly applicationRuleCollection?: FirewallPolicyRuleCollectionGroupApplicationRuleCollection[];
    /**
     * nat_rule_collection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#nat_rule_collection FirewallPolicyRuleCollectionGroup#nat_rule_collection}
     *
     * @stability stable
     */
    readonly natRuleCollection?: FirewallPolicyRuleCollectionGroupNatRuleCollection[];
    /**
     * network_rule_collection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#network_rule_collection FirewallPolicyRuleCollectionGroup#network_rule_collection}
     *
     * @stability stable
     */
    readonly networkRuleCollection?: FirewallPolicyRuleCollectionGroupNetworkRuleCollection[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#timeouts FirewallPolicyRuleCollectionGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FirewallPolicyRuleCollectionGroupTimeouts;
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupApplicationRuleCollectionRuleProtocols {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#port FirewallPolicyRuleCollectionGroup#port}.
     *
     * @stability stable
     */
    readonly port: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#type FirewallPolicyRuleCollectionGroup#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupApplicationRuleCollectionRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#description FirewallPolicyRuleCollectionGroup#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_addresses FirewallPolicyRuleCollectionGroup#destination_addresses}.
     *
     * @stability stable
     */
    readonly destinationAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_fqdn_tags FirewallPolicyRuleCollectionGroup#destination_fqdn_tags}.
     *
     * @stability stable
     */
    readonly destinationFqdnTags?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_fqdns FirewallPolicyRuleCollectionGroup#destination_fqdns}.
     *
     * @stability stable
     */
    readonly destinationFqdns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_urls FirewallPolicyRuleCollectionGroup#destination_urls}.
     *
     * @stability stable
     */
    readonly destinationUrls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_addresses FirewallPolicyRuleCollectionGroup#source_addresses}.
     *
     * @stability stable
     */
    readonly sourceAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_ip_groups FirewallPolicyRuleCollectionGroup#source_ip_groups}.
     *
     * @stability stable
     */
    readonly sourceIpGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#terminate_tls FirewallPolicyRuleCollectionGroup#terminate_tls}.
     *
     * @stability stable
     */
    readonly terminateTls?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#web_categories FirewallPolicyRuleCollectionGroup#web_categories}.
     *
     * @stability stable
     */
    readonly webCategories?: string[];
    /**
     * protocols block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#protocols FirewallPolicyRuleCollectionGroup#protocols}
     *
     * @stability stable
     */
    readonly protocols?: FirewallPolicyRuleCollectionGroupApplicationRuleCollectionRuleProtocols[];
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupApplicationRuleCollection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#action FirewallPolicyRuleCollectionGroup#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#priority FirewallPolicyRuleCollectionGroup#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#rule FirewallPolicyRuleCollectionGroup#rule}
     *
     * @stability stable
     */
    readonly rule: FirewallPolicyRuleCollectionGroupApplicationRuleCollectionRule[];
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupNatRuleCollectionRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_address FirewallPolicyRuleCollectionGroup#destination_address}.
     *
     * @stability stable
     */
    readonly destinationAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_ports FirewallPolicyRuleCollectionGroup#destination_ports}.
     *
     * @stability stable
     */
    readonly destinationPorts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#protocols FirewallPolicyRuleCollectionGroup#protocols}.
     *
     * @stability stable
     */
    readonly protocols: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_addresses FirewallPolicyRuleCollectionGroup#source_addresses}.
     *
     * @stability stable
     */
    readonly sourceAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_ip_groups FirewallPolicyRuleCollectionGroup#source_ip_groups}.
     *
     * @stability stable
     */
    readonly sourceIpGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#translated_address FirewallPolicyRuleCollectionGroup#translated_address}.
     *
     * @stability stable
     */
    readonly translatedAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#translated_fqdn FirewallPolicyRuleCollectionGroup#translated_fqdn}.
     *
     * @stability stable
     */
    readonly translatedFqdn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#translated_port FirewallPolicyRuleCollectionGroup#translated_port}.
     *
     * @stability stable
     */
    readonly translatedPort: number;
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupNatRuleCollection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#action FirewallPolicyRuleCollectionGroup#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#priority FirewallPolicyRuleCollectionGroup#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#rule FirewallPolicyRuleCollectionGroup#rule}
     *
     * @stability stable
     */
    readonly rule: FirewallPolicyRuleCollectionGroupNatRuleCollectionRule[];
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupNetworkRuleCollectionRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_addresses FirewallPolicyRuleCollectionGroup#destination_addresses}.
     *
     * @stability stable
     */
    readonly destinationAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_fqdns FirewallPolicyRuleCollectionGroup#destination_fqdns}.
     *
     * @stability stable
     */
    readonly destinationFqdns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_ip_groups FirewallPolicyRuleCollectionGroup#destination_ip_groups}.
     *
     * @stability stable
     */
    readonly destinationIpGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#destination_ports FirewallPolicyRuleCollectionGroup#destination_ports}.
     *
     * @stability stable
     */
    readonly destinationPorts: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#protocols FirewallPolicyRuleCollectionGroup#protocols}.
     *
     * @stability stable
     */
    readonly protocols: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_addresses FirewallPolicyRuleCollectionGroup#source_addresses}.
     *
     * @stability stable
     */
    readonly sourceAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#source_ip_groups FirewallPolicyRuleCollectionGroup#source_ip_groups}.
     *
     * @stability stable
     */
    readonly sourceIpGroups?: string[];
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupNetworkRuleCollection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#action FirewallPolicyRuleCollectionGroup#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#name FirewallPolicyRuleCollectionGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#priority FirewallPolicyRuleCollectionGroup#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#rule FirewallPolicyRuleCollectionGroup#rule}
     *
     * @stability stable
     */
    readonly rule: FirewallPolicyRuleCollectionGroupNetworkRuleCollectionRule[];
}
/**
 * @stability stable
 */
export interface FirewallPolicyRuleCollectionGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#create FirewallPolicyRuleCollectionGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#delete FirewallPolicyRuleCollectionGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#read FirewallPolicyRuleCollectionGroup#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html#update FirewallPolicyRuleCollectionGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class FirewallPolicyRuleCollectionGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html azurerm_firewall_policy_rule_collection_group}.
 *
 * @stability stable
 */
export declare class FirewallPolicyRuleCollectionGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/firewall_policy_rule_collection_group.html azurerm_firewall_policy_rule_collection_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FirewallPolicyRuleCollectionGroupConfig);
    private _firewallPolicyId?;
    /**
     * @stability stable
     */
    get firewallPolicyId(): string;
    /**
     * @stability stable
     */
    set firewallPolicyId(value: string);
    /**
     * @stability stable
     */
    get firewallPolicyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _applicationRuleCollection?;
    /**
     * @stability stable
     */
    get applicationRuleCollection(): FirewallPolicyRuleCollectionGroupApplicationRuleCollection[] | undefined;
    /**
     * @stability stable
     */
    set applicationRuleCollection(value: FirewallPolicyRuleCollectionGroupApplicationRuleCollection[] | undefined);
    /**
     * @stability stable
     */
    resetApplicationRuleCollection(): void;
    /**
     * @stability stable
     */
    get applicationRuleCollectionInput(): FirewallPolicyRuleCollectionGroupApplicationRuleCollection[] | undefined;
    private _natRuleCollection?;
    /**
     * @stability stable
     */
    get natRuleCollection(): FirewallPolicyRuleCollectionGroupNatRuleCollection[] | undefined;
    /**
     * @stability stable
     */
    set natRuleCollection(value: FirewallPolicyRuleCollectionGroupNatRuleCollection[] | undefined);
    /**
     * @stability stable
     */
    resetNatRuleCollection(): void;
    /**
     * @stability stable
     */
    get natRuleCollectionInput(): FirewallPolicyRuleCollectionGroupNatRuleCollection[] | undefined;
    private _networkRuleCollection?;
    /**
     * @stability stable
     */
    get networkRuleCollection(): FirewallPolicyRuleCollectionGroupNetworkRuleCollection[] | undefined;
    /**
     * @stability stable
     */
    set networkRuleCollection(value: FirewallPolicyRuleCollectionGroupNetworkRuleCollection[] | undefined);
    /**
     * @stability stable
     */
    resetNetworkRuleCollection(): void;
    /**
     * @stability stable
     */
    get networkRuleCollectionInput(): FirewallPolicyRuleCollectionGroupNetworkRuleCollection[] | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): FirewallPolicyRuleCollectionGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FirewallPolicyRuleCollectionGroupTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FirewallPolicyRuleCollectionGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
