import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MssqlDatabaseConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#auto_pause_delay_in_minutes MssqlDatabase#auto_pause_delay_in_minutes}.
     *
     * @stability stable
     */
    readonly autoPauseDelayInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#collation MssqlDatabase#collation}.
     *
     * @stability stable
     */
    readonly collation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#create_mode MssqlDatabase#create_mode}.
     *
     * @stability stable
     */
    readonly createMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#creation_source_database_id MssqlDatabase#creation_source_database_id}.
     *
     * @stability stable
     */
    readonly creationSourceDatabaseId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#elastic_pool_id MssqlDatabase#elastic_pool_id}.
     *
     * @stability stable
     */
    readonly elasticPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#extended_auditing_policy MssqlDatabase#extended_auditing_policy}.
     *
     * @stability stable
     */
    readonly extendedAuditingPolicy?: MssqlDatabaseExtendedAuditingPolicy[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#geo_backup_enabled MssqlDatabase#geo_backup_enabled}.
     *
     * @stability stable
     */
    readonly geoBackupEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#license_type MssqlDatabase#license_type}.
     *
     * @stability stable
     */
    readonly licenseType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#max_size_gb MssqlDatabase#max_size_gb}.
     *
     * @stability stable
     */
    readonly maxSizeGb?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#min_capacity MssqlDatabase#min_capacity}.
     *
     * @stability stable
     */
    readonly minCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#name MssqlDatabase#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#read_replica_count MssqlDatabase#read_replica_count}.
     *
     * @stability stable
     */
    readonly readReplicaCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#read_scale MssqlDatabase#read_scale}.
     *
     * @stability stable
     */
    readonly readScale?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#recover_database_id MssqlDatabase#recover_database_id}.
     *
     * @stability stable
     */
    readonly recoverDatabaseId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#restore_dropped_database_id MssqlDatabase#restore_dropped_database_id}.
     *
     * @stability stable
     */
    readonly restoreDroppedDatabaseId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#restore_point_in_time MssqlDatabase#restore_point_in_time}.
     *
     * @stability stable
     */
    readonly restorePointInTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#sample_name MssqlDatabase#sample_name}.
     *
     * @stability stable
     */
    readonly sampleName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#server_id MssqlDatabase#server_id}.
     *
     * @stability stable
     */
    readonly serverId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#sku_name MssqlDatabase#sku_name}.
     *
     * @stability stable
     */
    readonly skuName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_account_type MssqlDatabase#storage_account_type}.
     *
     * @stability stable
     */
    readonly storageAccountType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#tags MssqlDatabase#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#zone_redundant MssqlDatabase#zone_redundant}.
     *
     * @stability stable
     */
    readonly zoneRedundant?: boolean | cdktf.IResolvable;
    /**
     * long_term_retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#long_term_retention_policy MssqlDatabase#long_term_retention_policy}
     *
     * @stability stable
     */
    readonly longTermRetentionPolicy?: MssqlDatabaseLongTermRetentionPolicy;
    /**
     * short_term_retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#short_term_retention_policy MssqlDatabase#short_term_retention_policy}
     *
     * @stability stable
     */
    readonly shortTermRetentionPolicy?: MssqlDatabaseShortTermRetentionPolicy;
    /**
     * threat_detection_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#threat_detection_policy MssqlDatabase#threat_detection_policy}
     *
     * @stability stable
     */
    readonly threatDetectionPolicy?: MssqlDatabaseThreatDetectionPolicy;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#timeouts MssqlDatabase#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MssqlDatabaseTimeouts;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseExtendedAuditingPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#log_monitoring_enabled MssqlDatabase#log_monitoring_enabled}.
     *
     * @stability stable
     */
    readonly logMonitoringEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#retention_in_days MssqlDatabase#retention_in_days}.
     *
     * @stability stable
     */
    readonly retentionInDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_account_access_key MssqlDatabase#storage_account_access_key}.
     *
     * @stability stable
     */
    readonly storageAccountAccessKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_account_access_key_is_secondary MssqlDatabase#storage_account_access_key_is_secondary}.
     *
     * @stability stable
     */
    readonly storageAccountAccessKeyIsSecondary?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_endpoint MssqlDatabase#storage_endpoint}.
     *
     * @stability stable
     */
    readonly storageEndpoint?: string;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseLongTermRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#monthly_retention MssqlDatabase#monthly_retention}.
     *
     * @stability stable
     */
    readonly monthlyRetention?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#week_of_year MssqlDatabase#week_of_year}.
     *
     * @stability stable
     */
    readonly weekOfYear?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#weekly_retention MssqlDatabase#weekly_retention}.
     *
     * @stability stable
     */
    readonly weeklyRetention?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#yearly_retention MssqlDatabase#yearly_retention}.
     *
     * @stability stable
     */
    readonly yearlyRetention?: string;
}
/**
 * @stability stable
 */
export declare class MssqlDatabaseLongTermRetentionPolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _monthlyRetention?;
    /**
     * @stability stable
     */
    get monthlyRetention(): string | undefined;
    /**
     * @stability stable
     */
    set monthlyRetention(value: string | undefined);
    /**
     * @stability stable
     */
    resetMonthlyRetention(): void;
    /**
     * @stability stable
     */
    get monthlyRetentionInput(): string | undefined;
    private _weekOfYear?;
    /**
     * @stability stable
     */
    get weekOfYear(): number | undefined;
    /**
     * @stability stable
     */
    set weekOfYear(value: number | undefined);
    /**
     * @stability stable
     */
    resetWeekOfYear(): void;
    /**
     * @stability stable
     */
    get weekOfYearInput(): number | undefined;
    private _weeklyRetention?;
    /**
     * @stability stable
     */
    get weeklyRetention(): string | undefined;
    /**
     * @stability stable
     */
    set weeklyRetention(value: string | undefined);
    /**
     * @stability stable
     */
    resetWeeklyRetention(): void;
    /**
     * @stability stable
     */
    get weeklyRetentionInput(): string | undefined;
    private _yearlyRetention?;
    /**
     * @stability stable
     */
    get yearlyRetention(): string | undefined;
    /**
     * @stability stable
     */
    set yearlyRetention(value: string | undefined);
    /**
     * @stability stable
     */
    resetYearlyRetention(): void;
    /**
     * @stability stable
     */
    get yearlyRetentionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseShortTermRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#retention_days MssqlDatabase#retention_days}.
     *
     * @stability stable
     */
    readonly retentionDays: number;
}
/**
 * @stability stable
 */
export declare class MssqlDatabaseShortTermRetentionPolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _retentionDays?;
    /**
     * @stability stable
     */
    get retentionDays(): number;
    /**
     * @stability stable
     */
    set retentionDays(value: number);
    /**
     * @stability stable
     */
    get retentionDaysInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseThreatDetectionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#disabled_alerts MssqlDatabase#disabled_alerts}.
     *
     * @stability stable
     */
    readonly disabledAlerts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#email_account_admins MssqlDatabase#email_account_admins}.
     *
     * @stability stable
     */
    readonly emailAccountAdmins?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#email_addresses MssqlDatabase#email_addresses}.
     *
     * @stability stable
     */
    readonly emailAddresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#retention_days MssqlDatabase#retention_days}.
     *
     * @stability stable
     */
    readonly retentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#state MssqlDatabase#state}.
     *
     * @stability stable
     */
    readonly state?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_account_access_key MssqlDatabase#storage_account_access_key}.
     *
     * @stability stable
     */
    readonly storageAccountAccessKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#storage_endpoint MssqlDatabase#storage_endpoint}.
     *
     * @stability stable
     */
    readonly storageEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#use_server_default MssqlDatabase#use_server_default}.
     *
     * @stability stable
     */
    readonly useServerDefault?: string;
}
/**
 * @stability stable
 */
export declare class MssqlDatabaseThreatDetectionPolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _disabledAlerts?;
    /**
     * @stability stable
     */
    get disabledAlerts(): string[] | undefined;
    /**
     * @stability stable
     */
    set disabledAlerts(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetDisabledAlerts(): void;
    /**
     * @stability stable
     */
    get disabledAlertsInput(): string[] | undefined;
    private _emailAccountAdmins?;
    /**
     * @stability stable
     */
    get emailAccountAdmins(): string | undefined;
    /**
     * @stability stable
     */
    set emailAccountAdmins(value: string | undefined);
    /**
     * @stability stable
     */
    resetEmailAccountAdmins(): void;
    /**
     * @stability stable
     */
    get emailAccountAdminsInput(): string | undefined;
    private _emailAddresses?;
    /**
     * @stability stable
     */
    get emailAddresses(): string[] | undefined;
    /**
     * @stability stable
     */
    set emailAddresses(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetEmailAddresses(): void;
    /**
     * @stability stable
     */
    get emailAddressesInput(): string[] | undefined;
    private _retentionDays?;
    /**
     * @stability stable
     */
    get retentionDays(): number | undefined;
    /**
     * @stability stable
     */
    set retentionDays(value: number | undefined);
    /**
     * @stability stable
     */
    resetRetentionDays(): void;
    /**
     * @stability stable
     */
    get retentionDaysInput(): number | undefined;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string | undefined;
    /**
     * @stability stable
     */
    set state(value: string | undefined);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _storageAccountAccessKey?;
    /**
     * @stability stable
     */
    get storageAccountAccessKey(): string | undefined;
    /**
     * @stability stable
     */
    set storageAccountAccessKey(value: string | undefined);
    /**
     * @stability stable
     */
    resetStorageAccountAccessKey(): void;
    /**
     * @stability stable
     */
    get storageAccountAccessKeyInput(): string | undefined;
    private _storageEndpoint?;
    /**
     * @stability stable
     */
    get storageEndpoint(): string | undefined;
    /**
     * @stability stable
     */
    set storageEndpoint(value: string | undefined);
    /**
     * @stability stable
     */
    resetStorageEndpoint(): void;
    /**
     * @stability stable
     */
    get storageEndpointInput(): string | undefined;
    private _useServerDefault?;
    /**
     * @stability stable
     */
    get useServerDefault(): string | undefined;
    /**
     * @stability stable
     */
    set useServerDefault(value: string | undefined);
    /**
     * @stability stable
     */
    resetUseServerDefault(): void;
    /**
     * @stability stable
     */
    get useServerDefaultInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface MssqlDatabaseTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#create MssqlDatabase#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#delete MssqlDatabase#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#read MssqlDatabase#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html#update MssqlDatabase#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class MssqlDatabaseTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html azurerm_mssql_database}.
 *
 * @stability stable
 */
export declare class MssqlDatabase extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/mssql_database.html azurerm_mssql_database} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MssqlDatabaseConfig);
    private _autoPauseDelayInMinutes?;
    /**
     * @stability stable
     */
    get autoPauseDelayInMinutes(): number | undefined;
    /**
     * @stability stable
     */
    set autoPauseDelayInMinutes(value: number | undefined);
    /**
     * @stability stable
     */
    resetAutoPauseDelayInMinutes(): void;
    /**
     * @stability stable
     */
    get autoPauseDelayInMinutesInput(): number | undefined;
    private _collation?;
    /**
     * @stability stable
     */
    get collation(): string | undefined;
    /**
     * @stability stable
     */
    set collation(value: string | undefined);
    /**
     * @stability stable
     */
    resetCollation(): void;
    /**
     * @stability stable
     */
    get collationInput(): string | undefined;
    private _createMode?;
    /**
     * @stability stable
     */
    get createMode(): string | undefined;
    /**
     * @stability stable
     */
    set createMode(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreateMode(): void;
    /**
     * @stability stable
     */
    get createModeInput(): string | undefined;
    private _creationSourceDatabaseId?;
    /**
     * @stability stable
     */
    get creationSourceDatabaseId(): string | undefined;
    /**
     * @stability stable
     */
    set creationSourceDatabaseId(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreationSourceDatabaseId(): void;
    /**
     * @stability stable
     */
    get creationSourceDatabaseIdInput(): string | undefined;
    private _elasticPoolId?;
    /**
     * @stability stable
     */
    get elasticPoolId(): string | undefined;
    /**
     * @stability stable
     */
    set elasticPoolId(value: string | undefined);
    /**
     * @stability stable
     */
    resetElasticPoolId(): void;
    /**
     * @stability stable
     */
    get elasticPoolIdInput(): string | undefined;
    private _extendedAuditingPolicy?;
    /**
     * @stability stable
     */
    get extendedAuditingPolicy(): MssqlDatabaseExtendedAuditingPolicy[] | undefined;
    /**
     * @stability stable
     */
    set extendedAuditingPolicy(value: MssqlDatabaseExtendedAuditingPolicy[] | undefined);
    /**
     * @stability stable
     */
    resetExtendedAuditingPolicy(): void;
    /**
     * @stability stable
     */
    get extendedAuditingPolicyInput(): MssqlDatabaseExtendedAuditingPolicy[] | undefined;
    private _geoBackupEnabled?;
    /**
     * @stability stable
     */
    get geoBackupEnabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set geoBackupEnabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetGeoBackupEnabled(): void;
    /**
     * @stability stable
     */
    get geoBackupEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _licenseType?;
    /**
     * @stability stable
     */
    get licenseType(): string | undefined;
    /**
     * @stability stable
     */
    set licenseType(value: string | undefined);
    /**
     * @stability stable
     */
    resetLicenseType(): void;
    /**
     * @stability stable
     */
    get licenseTypeInput(): string | undefined;
    private _maxSizeGb?;
    /**
     * @stability stable
     */
    get maxSizeGb(): number | undefined;
    /**
     * @stability stable
     */
    set maxSizeGb(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxSizeGb(): void;
    /**
     * @stability stable
     */
    get maxSizeGbInput(): number | undefined;
    private _minCapacity?;
    /**
     * @stability stable
     */
    get minCapacity(): number | undefined;
    /**
     * @stability stable
     */
    set minCapacity(value: number | undefined);
    /**
     * @stability stable
     */
    resetMinCapacity(): void;
    /**
     * @stability stable
     */
    get minCapacityInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _readReplicaCount?;
    /**
     * @stability stable
     */
    get readReplicaCount(): number | undefined;
    /**
     * @stability stable
     */
    set readReplicaCount(value: number | undefined);
    /**
     * @stability stable
     */
    resetReadReplicaCount(): void;
    /**
     * @stability stable
     */
    get readReplicaCountInput(): number | undefined;
    private _readScale?;
    /**
     * @stability stable
     */
    get readScale(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set readScale(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetReadScale(): void;
    /**
     * @stability stable
     */
    get readScaleInput(): boolean | cdktf.IResolvable | undefined;
    private _recoverDatabaseId?;
    /**
     * @stability stable
     */
    get recoverDatabaseId(): string | undefined;
    /**
     * @stability stable
     */
    set recoverDatabaseId(value: string | undefined);
    /**
     * @stability stable
     */
    resetRecoverDatabaseId(): void;
    /**
     * @stability stable
     */
    get recoverDatabaseIdInput(): string | undefined;
    private _restoreDroppedDatabaseId?;
    /**
     * @stability stable
     */
    get restoreDroppedDatabaseId(): string | undefined;
    /**
     * @stability stable
     */
    set restoreDroppedDatabaseId(value: string | undefined);
    /**
     * @stability stable
     */
    resetRestoreDroppedDatabaseId(): void;
    /**
     * @stability stable
     */
    get restoreDroppedDatabaseIdInput(): string | undefined;
    private _restorePointInTime?;
    /**
     * @stability stable
     */
    get restorePointInTime(): string | undefined;
    /**
     * @stability stable
     */
    set restorePointInTime(value: string | undefined);
    /**
     * @stability stable
     */
    resetRestorePointInTime(): void;
    /**
     * @stability stable
     */
    get restorePointInTimeInput(): string | undefined;
    private _sampleName?;
    /**
     * @stability stable
     */
    get sampleName(): string | undefined;
    /**
     * @stability stable
     */
    set sampleName(value: string | undefined);
    /**
     * @stability stable
     */
    resetSampleName(): void;
    /**
     * @stability stable
     */
    get sampleNameInput(): string | undefined;
    private _serverId?;
    /**
     * @stability stable
     */
    get serverId(): string;
    /**
     * @stability stable
     */
    set serverId(value: string);
    /**
     * @stability stable
     */
    get serverIdInput(): string | undefined;
    private _skuName?;
    /**
     * @stability stable
     */
    get skuName(): string | undefined;
    /**
     * @stability stable
     */
    set skuName(value: string | undefined);
    /**
     * @stability stable
     */
    resetSkuName(): void;
    /**
     * @stability stable
     */
    get skuNameInput(): string | undefined;
    private _storageAccountType?;
    /**
     * @stability stable
     */
    get storageAccountType(): string | undefined;
    /**
     * @stability stable
     */
    set storageAccountType(value: string | undefined);
    /**
     * @stability stable
     */
    resetStorageAccountType(): void;
    /**
     * @stability stable
     */
    get storageAccountTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _zoneRedundant?;
    /**
     * @stability stable
     */
    get zoneRedundant(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set zoneRedundant(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetZoneRedundant(): void;
    /**
     * @stability stable
     */
    get zoneRedundantInput(): boolean | cdktf.IResolvable | undefined;
    private _longTermRetentionPolicy?;
    private __longTermRetentionPolicyOutput;
    /**
     * @stability stable
     */
    get longTermRetentionPolicy(): MssqlDatabaseLongTermRetentionPolicyOutputReference;
    /**
     * @stability stable
     */
    putLongTermRetentionPolicy(value: MssqlDatabaseLongTermRetentionPolicy | undefined): void;
    /**
     * @stability stable
     */
    resetLongTermRetentionPolicy(): void;
    /**
     * @stability stable
     */
    get longTermRetentionPolicyInput(): MssqlDatabaseLongTermRetentionPolicy | undefined;
    private _shortTermRetentionPolicy?;
    private __shortTermRetentionPolicyOutput;
    /**
     * @stability stable
     */
    get shortTermRetentionPolicy(): MssqlDatabaseShortTermRetentionPolicyOutputReference;
    /**
     * @stability stable
     */
    putShortTermRetentionPolicy(value: MssqlDatabaseShortTermRetentionPolicy | undefined): void;
    /**
     * @stability stable
     */
    resetShortTermRetentionPolicy(): void;
    /**
     * @stability stable
     */
    get shortTermRetentionPolicyInput(): MssqlDatabaseShortTermRetentionPolicy | undefined;
    private _threatDetectionPolicy?;
    private __threatDetectionPolicyOutput;
    /**
     * @stability stable
     */
    get threatDetectionPolicy(): MssqlDatabaseThreatDetectionPolicyOutputReference;
    /**
     * @stability stable
     */
    putThreatDetectionPolicy(value: MssqlDatabaseThreatDetectionPolicy | undefined): void;
    /**
     * @stability stable
     */
    resetThreatDetectionPolicy(): void;
    /**
     * @stability stable
     */
    get threatDetectionPolicyInput(): MssqlDatabaseThreatDetectionPolicy | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): MssqlDatabaseTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: MssqlDatabaseTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MssqlDatabaseTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
