import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceFabricClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#add_on_features ServiceFabricCluster#add_on_features}.
     *
     * @stability stable
     */
    readonly addOnFeatures?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#cluster_code_version ServiceFabricCluster#cluster_code_version}.
     *
     * @stability stable
     */
    readonly clusterCodeVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#location ServiceFabricCluster#location}.
     *
     * @stability stable
     */
    readonly location: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#management_endpoint ServiceFabricCluster#management_endpoint}.
     *
     * @stability stable
     */
    readonly managementEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#name ServiceFabricCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#reliability_level ServiceFabricCluster#reliability_level}.
     *
     * @stability stable
     */
    readonly reliabilityLevel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#resource_group_name ServiceFabricCluster#resource_group_name}.
     *
     * @stability stable
     */
    readonly resourceGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#service_fabric_zonal_upgrade_mode ServiceFabricCluster#service_fabric_zonal_upgrade_mode}.
     *
     * @stability stable
     */
    readonly serviceFabricZonalUpgradeMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#tags ServiceFabricCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#upgrade_mode ServiceFabricCluster#upgrade_mode}.
     *
     * @stability stable
     */
    readonly upgradeMode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#vm_image ServiceFabricCluster#vm_image}.
     *
     * @stability stable
     */
    readonly vmImage: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#vmss_zonal_upgrade_mode ServiceFabricCluster#vmss_zonal_upgrade_mode}.
     *
     * @stability stable
     */
    readonly vmssZonalUpgradeMode?: string;
    /**
     * azure_active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#azure_active_directory ServiceFabricCluster#azure_active_directory}
     *
     * @stability stable
     */
    readonly azureActiveDirectory?: ServiceFabricClusterAzureActiveDirectory;
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate ServiceFabricCluster#certificate}
     *
     * @stability stable
     */
    readonly certificate?: ServiceFabricClusterCertificate;
    /**
     * certificate_common_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate_common_names ServiceFabricCluster#certificate_common_names}
     *
     * @stability stable
     */
    readonly certificateCommonNames?: ServiceFabricClusterCertificateCommonNames;
    /**
     * client_certificate_common_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#client_certificate_common_name ServiceFabricCluster#client_certificate_common_name}
     *
     * @stability stable
     */
    readonly clientCertificateCommonName?: ServiceFabricClusterClientCertificateCommonName[];
    /**
     * client_certificate_thumbprint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#client_certificate_thumbprint ServiceFabricCluster#client_certificate_thumbprint}
     *
     * @stability stable
     */
    readonly clientCertificateThumbprint?: ServiceFabricClusterClientCertificateThumbprint[];
    /**
     * diagnostics_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#diagnostics_config ServiceFabricCluster#diagnostics_config}
     *
     * @stability stable
     */
    readonly diagnosticsConfig?: ServiceFabricClusterDiagnosticsConfig;
    /**
     * fabric_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#fabric_settings ServiceFabricCluster#fabric_settings}
     *
     * @stability stable
     */
    readonly fabricSettings?: ServiceFabricClusterFabricSettings[];
    /**
     * node_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#node_type ServiceFabricCluster#node_type}
     *
     * @stability stable
     */
    readonly nodeType: ServiceFabricClusterNodeType[];
    /**
     * reverse_proxy_certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#reverse_proxy_certificate ServiceFabricCluster#reverse_proxy_certificate}
     *
     * @stability stable
     */
    readonly reverseProxyCertificate?: ServiceFabricClusterReverseProxyCertificate;
    /**
     * reverse_proxy_certificate_common_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#reverse_proxy_certificate_common_names ServiceFabricCluster#reverse_proxy_certificate_common_names}
     *
     * @stability stable
     */
    readonly reverseProxyCertificateCommonNames?: ServiceFabricClusterReverseProxyCertificateCommonNames;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#timeouts ServiceFabricCluster#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ServiceFabricClusterTimeouts;
    /**
     * upgrade_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#upgrade_policy ServiceFabricCluster#upgrade_policy}
     *
     * @stability stable
     */
    readonly upgradePolicy?: ServiceFabricClusterUpgradePolicy;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterAzureActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#client_application_id ServiceFabricCluster#client_application_id}.
     *
     * @stability stable
     */
    readonly clientApplicationId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#cluster_application_id ServiceFabricCluster#cluster_application_id}.
     *
     * @stability stable
     */
    readonly clusterApplicationId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#tenant_id ServiceFabricCluster#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId: string;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterAzureActiveDirectoryOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _clientApplicationId?;
    /**
     * @stability stable
     */
    get clientApplicationId(): string;
    /**
     * @stability stable
     */
    set clientApplicationId(value: string);
    /**
     * @stability stable
     */
    get clientApplicationIdInput(): string | undefined;
    private _clusterApplicationId?;
    /**
     * @stability stable
     */
    get clusterApplicationId(): string;
    /**
     * @stability stable
     */
    set clusterApplicationId(value: string);
    /**
     * @stability stable
     */
    get clusterApplicationIdInput(): string | undefined;
    private _tenantId?;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    set tenantId(value: string);
    /**
     * @stability stable
     */
    get tenantIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#thumbprint ServiceFabricCluster#thumbprint}.
     *
     * @stability stable
     */
    readonly thumbprint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#thumbprint_secondary ServiceFabricCluster#thumbprint_secondary}.
     *
     * @stability stable
     */
    readonly thumbprintSecondary?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#x509_store_name ServiceFabricCluster#x509_store_name}.
     *
     * @stability stable
     */
    readonly x509StoreName: string;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterCertificateOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _thumbprint?;
    /**
     * @stability stable
     */
    get thumbprint(): string;
    /**
     * @stability stable
     */
    set thumbprint(value: string);
    /**
     * @stability stable
     */
    get thumbprintInput(): string | undefined;
    private _thumbprintSecondary?;
    /**
     * @stability stable
     */
    get thumbprintSecondary(): string | undefined;
    /**
     * @stability stable
     */
    set thumbprintSecondary(value: string | undefined);
    /**
     * @stability stable
     */
    resetThumbprintSecondary(): void;
    /**
     * @stability stable
     */
    get thumbprintSecondaryInput(): string | undefined;
    private _x509StoreName?;
    /**
     * @stability stable
     */
    get x509StoreName(): string;
    /**
     * @stability stable
     */
    set x509StoreName(value: string);
    /**
     * @stability stable
     */
    get x509StoreNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterCertificateCommonNamesCommonNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate_common_name ServiceFabricCluster#certificate_common_name}.
     *
     * @stability stable
     */
    readonly certificateCommonName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate_issuer_thumbprint ServiceFabricCluster#certificate_issuer_thumbprint}.
     *
     * @stability stable
     */
    readonly certificateIssuerThumbprint?: string;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterCertificateCommonNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#x509_store_name ServiceFabricCluster#x509_store_name}.
     *
     * @stability stable
     */
    readonly x509StoreName: string;
    /**
     * common_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#common_names ServiceFabricCluster#common_names}
     *
     * @stability stable
     */
    readonly commonNames: ServiceFabricClusterCertificateCommonNamesCommonNames[];
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterCertificateCommonNamesOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _x509StoreName?;
    /**
     * @stability stable
     */
    get x509StoreName(): string;
    /**
     * @stability stable
     */
    set x509StoreName(value: string);
    /**
     * @stability stable
     */
    get x509StoreNameInput(): string | undefined;
    private _commonNames?;
    /**
     * @stability stable
     */
    get commonNames(): ServiceFabricClusterCertificateCommonNamesCommonNames[];
    /**
     * @stability stable
     */
    set commonNames(value: ServiceFabricClusterCertificateCommonNamesCommonNames[]);
    /**
     * @stability stable
     */
    get commonNamesInput(): ServiceFabricClusterCertificateCommonNamesCommonNames[] | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterClientCertificateCommonName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#common_name ServiceFabricCluster#common_name}.
     *
     * @stability stable
     */
    readonly commonName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#is_admin ServiceFabricCluster#is_admin}.
     *
     * @stability stable
     */
    readonly isAdmin: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#issuer_thumbprint ServiceFabricCluster#issuer_thumbprint}.
     *
     * @stability stable
     */
    readonly issuerThumbprint?: string;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterClientCertificateThumbprint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#is_admin ServiceFabricCluster#is_admin}.
     *
     * @stability stable
     */
    readonly isAdmin: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#thumbprint ServiceFabricCluster#thumbprint}.
     *
     * @stability stable
     */
    readonly thumbprint: string;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterDiagnosticsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#blob_endpoint ServiceFabricCluster#blob_endpoint}.
     *
     * @stability stable
     */
    readonly blobEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#protected_account_key_name ServiceFabricCluster#protected_account_key_name}.
     *
     * @stability stable
     */
    readonly protectedAccountKeyName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#queue_endpoint ServiceFabricCluster#queue_endpoint}.
     *
     * @stability stable
     */
    readonly queueEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#storage_account_name ServiceFabricCluster#storage_account_name}.
     *
     * @stability stable
     */
    readonly storageAccountName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#table_endpoint ServiceFabricCluster#table_endpoint}.
     *
     * @stability stable
     */
    readonly tableEndpoint: string;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterDiagnosticsConfigOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _blobEndpoint?;
    /**
     * @stability stable
     */
    get blobEndpoint(): string;
    /**
     * @stability stable
     */
    set blobEndpoint(value: string);
    /**
     * @stability stable
     */
    get blobEndpointInput(): string | undefined;
    private _protectedAccountKeyName?;
    /**
     * @stability stable
     */
    get protectedAccountKeyName(): string;
    /**
     * @stability stable
     */
    set protectedAccountKeyName(value: string);
    /**
     * @stability stable
     */
    get protectedAccountKeyNameInput(): string | undefined;
    private _queueEndpoint?;
    /**
     * @stability stable
     */
    get queueEndpoint(): string;
    /**
     * @stability stable
     */
    set queueEndpoint(value: string);
    /**
     * @stability stable
     */
    get queueEndpointInput(): string | undefined;
    private _storageAccountName?;
    /**
     * @stability stable
     */
    get storageAccountName(): string;
    /**
     * @stability stable
     */
    set storageAccountName(value: string);
    /**
     * @stability stable
     */
    get storageAccountNameInput(): string | undefined;
    private _tableEndpoint?;
    /**
     * @stability stable
     */
    get tableEndpoint(): string;
    /**
     * @stability stable
     */
    set tableEndpoint(value: string);
    /**
     * @stability stable
     */
    get tableEndpointInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterFabricSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#name ServiceFabricCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#parameters ServiceFabricCluster#parameters}.
     *
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterNodeTypeApplicationPorts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#end_port ServiceFabricCluster#end_port}.
     *
     * @stability stable
     */
    readonly endPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#start_port ServiceFabricCluster#start_port}.
     *
     * @stability stable
     */
    readonly startPort: number;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterNodeTypeApplicationPortsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _endPort?;
    /**
     * @stability stable
     */
    get endPort(): number;
    /**
     * @stability stable
     */
    set endPort(value: number);
    /**
     * @stability stable
     */
    get endPortInput(): number | undefined;
    private _startPort?;
    /**
     * @stability stable
     */
    get startPort(): number;
    /**
     * @stability stable
     */
    set startPort(value: number);
    /**
     * @stability stable
     */
    get startPortInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterNodeTypeEphemeralPorts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#end_port ServiceFabricCluster#end_port}.
     *
     * @stability stable
     */
    readonly endPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#start_port ServiceFabricCluster#start_port}.
     *
     * @stability stable
     */
    readonly startPort: number;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterNodeTypeEphemeralPortsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _endPort?;
    /**
     * @stability stable
     */
    get endPort(): number;
    /**
     * @stability stable
     */
    set endPort(value: number);
    /**
     * @stability stable
     */
    get endPortInput(): number | undefined;
    private _startPort?;
    /**
     * @stability stable
     */
    get startPort(): number;
    /**
     * @stability stable
     */
    set startPort(value: number);
    /**
     * @stability stable
     */
    get startPortInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterNodeType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#capacities ServiceFabricCluster#capacities}.
     *
     * @stability stable
     */
    readonly capacities?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#client_endpoint_port ServiceFabricCluster#client_endpoint_port}.
     *
     * @stability stable
     */
    readonly clientEndpointPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#durability_level ServiceFabricCluster#durability_level}.
     *
     * @stability stable
     */
    readonly durabilityLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#http_endpoint_port ServiceFabricCluster#http_endpoint_port}.
     *
     * @stability stable
     */
    readonly httpEndpointPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#instance_count ServiceFabricCluster#instance_count}.
     *
     * @stability stable
     */
    readonly instanceCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#is_primary ServiceFabricCluster#is_primary}.
     *
     * @stability stable
     */
    readonly isPrimary: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#is_stateless ServiceFabricCluster#is_stateless}.
     *
     * @stability stable
     */
    readonly isStateless?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#multiple_availability_zones ServiceFabricCluster#multiple_availability_zones}.
     *
     * @stability stable
     */
    readonly multipleAvailabilityZones?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#name ServiceFabricCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#placement_properties ServiceFabricCluster#placement_properties}.
     *
     * @stability stable
     */
    readonly placementProperties?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#reverse_proxy_endpoint_port ServiceFabricCluster#reverse_proxy_endpoint_port}.
     *
     * @stability stable
     */
    readonly reverseProxyEndpointPort?: number;
    /**
     * application_ports block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#application_ports ServiceFabricCluster#application_ports}
     *
     * @stability stable
     */
    readonly applicationPorts?: ServiceFabricClusterNodeTypeApplicationPorts;
    /**
     * ephemeral_ports block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#ephemeral_ports ServiceFabricCluster#ephemeral_ports}
     *
     * @stability stable
     */
    readonly ephemeralPorts?: ServiceFabricClusterNodeTypeEphemeralPorts;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterReverseProxyCertificate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#thumbprint ServiceFabricCluster#thumbprint}.
     *
     * @stability stable
     */
    readonly thumbprint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#thumbprint_secondary ServiceFabricCluster#thumbprint_secondary}.
     *
     * @stability stable
     */
    readonly thumbprintSecondary?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#x509_store_name ServiceFabricCluster#x509_store_name}.
     *
     * @stability stable
     */
    readonly x509StoreName: string;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterReverseProxyCertificateOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _thumbprint?;
    /**
     * @stability stable
     */
    get thumbprint(): string;
    /**
     * @stability stable
     */
    set thumbprint(value: string);
    /**
     * @stability stable
     */
    get thumbprintInput(): string | undefined;
    private _thumbprintSecondary?;
    /**
     * @stability stable
     */
    get thumbprintSecondary(): string | undefined;
    /**
     * @stability stable
     */
    set thumbprintSecondary(value: string | undefined);
    /**
     * @stability stable
     */
    resetThumbprintSecondary(): void;
    /**
     * @stability stable
     */
    get thumbprintSecondaryInput(): string | undefined;
    private _x509StoreName?;
    /**
     * @stability stable
     */
    get x509StoreName(): string;
    /**
     * @stability stable
     */
    set x509StoreName(value: string);
    /**
     * @stability stable
     */
    get x509StoreNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterReverseProxyCertificateCommonNamesCommonNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate_common_name ServiceFabricCluster#certificate_common_name}.
     *
     * @stability stable
     */
    readonly certificateCommonName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#certificate_issuer_thumbprint ServiceFabricCluster#certificate_issuer_thumbprint}.
     *
     * @stability stable
     */
    readonly certificateIssuerThumbprint?: string;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterReverseProxyCertificateCommonNames {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#x509_store_name ServiceFabricCluster#x509_store_name}.
     *
     * @stability stable
     */
    readonly x509StoreName: string;
    /**
     * common_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#common_names ServiceFabricCluster#common_names}
     *
     * @stability stable
     */
    readonly commonNames: ServiceFabricClusterReverseProxyCertificateCommonNamesCommonNames[];
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterReverseProxyCertificateCommonNamesOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _x509StoreName?;
    /**
     * @stability stable
     */
    get x509StoreName(): string;
    /**
     * @stability stable
     */
    set x509StoreName(value: string);
    /**
     * @stability stable
     */
    get x509StoreNameInput(): string | undefined;
    private _commonNames?;
    /**
     * @stability stable
     */
    get commonNames(): ServiceFabricClusterReverseProxyCertificateCommonNamesCommonNames[];
    /**
     * @stability stable
     */
    set commonNames(value: ServiceFabricClusterReverseProxyCertificateCommonNamesCommonNames[]);
    /**
     * @stability stable
     */
    get commonNamesInput(): ServiceFabricClusterReverseProxyCertificateCommonNamesCommonNames[] | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#create ServiceFabricCluster#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#delete ServiceFabricCluster#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#read ServiceFabricCluster#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#update ServiceFabricCluster#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterUpgradePolicyDeltaHealthPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#max_delta_unhealthy_applications_percent ServiceFabricCluster#max_delta_unhealthy_applications_percent}.
     *
     * @stability stable
     */
    readonly maxDeltaUnhealthyApplicationsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#max_delta_unhealthy_nodes_percent ServiceFabricCluster#max_delta_unhealthy_nodes_percent}.
     *
     * @stability stable
     */
    readonly maxDeltaUnhealthyNodesPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#max_upgrade_domain_delta_unhealthy_nodes_percent ServiceFabricCluster#max_upgrade_domain_delta_unhealthy_nodes_percent}.
     *
     * @stability stable
     */
    readonly maxUpgradeDomainDeltaUnhealthyNodesPercent?: number;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterUpgradePolicyDeltaHealthPolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _maxDeltaUnhealthyApplicationsPercent?;
    /**
     * @stability stable
     */
    get maxDeltaUnhealthyApplicationsPercent(): number | undefined;
    /**
     * @stability stable
     */
    set maxDeltaUnhealthyApplicationsPercent(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxDeltaUnhealthyApplicationsPercent(): void;
    /**
     * @stability stable
     */
    get maxDeltaUnhealthyApplicationsPercentInput(): number | undefined;
    private _maxDeltaUnhealthyNodesPercent?;
    /**
     * @stability stable
     */
    get maxDeltaUnhealthyNodesPercent(): number | undefined;
    /**
     * @stability stable
     */
    set maxDeltaUnhealthyNodesPercent(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxDeltaUnhealthyNodesPercent(): void;
    /**
     * @stability stable
     */
    get maxDeltaUnhealthyNodesPercentInput(): number | undefined;
    private _maxUpgradeDomainDeltaUnhealthyNodesPercent?;
    /**
     * @stability stable
     */
    get maxUpgradeDomainDeltaUnhealthyNodesPercent(): number | undefined;
    /**
     * @stability stable
     */
    set maxUpgradeDomainDeltaUnhealthyNodesPercent(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxUpgradeDomainDeltaUnhealthyNodesPercent(): void;
    /**
     * @stability stable
     */
    get maxUpgradeDomainDeltaUnhealthyNodesPercentInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterUpgradePolicyHealthPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#max_unhealthy_applications_percent ServiceFabricCluster#max_unhealthy_applications_percent}.
     *
     * @stability stable
     */
    readonly maxUnhealthyApplicationsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#max_unhealthy_nodes_percent ServiceFabricCluster#max_unhealthy_nodes_percent}.
     *
     * @stability stable
     */
    readonly maxUnhealthyNodesPercent?: number;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterUpgradePolicyHealthPolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _maxUnhealthyApplicationsPercent?;
    /**
     * @stability stable
     */
    get maxUnhealthyApplicationsPercent(): number | undefined;
    /**
     * @stability stable
     */
    set maxUnhealthyApplicationsPercent(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxUnhealthyApplicationsPercent(): void;
    /**
     * @stability stable
     */
    get maxUnhealthyApplicationsPercentInput(): number | undefined;
    private _maxUnhealthyNodesPercent?;
    /**
     * @stability stable
     */
    get maxUnhealthyNodesPercent(): number | undefined;
    /**
     * @stability stable
     */
    set maxUnhealthyNodesPercent(value: number | undefined);
    /**
     * @stability stable
     */
    resetMaxUnhealthyNodesPercent(): void;
    /**
     * @stability stable
     */
    get maxUnhealthyNodesPercentInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface ServiceFabricClusterUpgradePolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#force_restart_enabled ServiceFabricCluster#force_restart_enabled}.
     *
     * @stability stable
     */
    readonly forceRestartEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#health_check_retry_timeout ServiceFabricCluster#health_check_retry_timeout}.
     *
     * @stability stable
     */
    readonly healthCheckRetryTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#health_check_stable_duration ServiceFabricCluster#health_check_stable_duration}.
     *
     * @stability stable
     */
    readonly healthCheckStableDuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#health_check_wait_duration ServiceFabricCluster#health_check_wait_duration}.
     *
     * @stability stable
     */
    readonly healthCheckWaitDuration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#upgrade_domain_timeout ServiceFabricCluster#upgrade_domain_timeout}.
     *
     * @stability stable
     */
    readonly upgradeDomainTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#upgrade_replica_set_check_timeout ServiceFabricCluster#upgrade_replica_set_check_timeout}.
     *
     * @stability stable
     */
    readonly upgradeReplicaSetCheckTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#upgrade_timeout ServiceFabricCluster#upgrade_timeout}.
     *
     * @stability stable
     */
    readonly upgradeTimeout?: string;
    /**
     * delta_health_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#delta_health_policy ServiceFabricCluster#delta_health_policy}
     *
     * @stability stable
     */
    readonly deltaHealthPolicy?: ServiceFabricClusterUpgradePolicyDeltaHealthPolicy;
    /**
     * health_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html#health_policy ServiceFabricCluster#health_policy}
     *
     * @stability stable
     */
    readonly healthPolicy?: ServiceFabricClusterUpgradePolicyHealthPolicy;
}
/**
 * @stability stable
 */
export declare class ServiceFabricClusterUpgradePolicyOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _forceRestartEnabled?;
    /**
     * @stability stable
     */
    get forceRestartEnabled(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set forceRestartEnabled(value: boolean | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetForceRestartEnabled(): void;
    /**
     * @stability stable
     */
    get forceRestartEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _healthCheckRetryTimeout?;
    /**
     * @stability stable
     */
    get healthCheckRetryTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set healthCheckRetryTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetHealthCheckRetryTimeout(): void;
    /**
     * @stability stable
     */
    get healthCheckRetryTimeoutInput(): string | undefined;
    private _healthCheckStableDuration?;
    /**
     * @stability stable
     */
    get healthCheckStableDuration(): string | undefined;
    /**
     * @stability stable
     */
    set healthCheckStableDuration(value: string | undefined);
    /**
     * @stability stable
     */
    resetHealthCheckStableDuration(): void;
    /**
     * @stability stable
     */
    get healthCheckStableDurationInput(): string | undefined;
    private _healthCheckWaitDuration?;
    /**
     * @stability stable
     */
    get healthCheckWaitDuration(): string | undefined;
    /**
     * @stability stable
     */
    set healthCheckWaitDuration(value: string | undefined);
    /**
     * @stability stable
     */
    resetHealthCheckWaitDuration(): void;
    /**
     * @stability stable
     */
    get healthCheckWaitDurationInput(): string | undefined;
    private _upgradeDomainTimeout?;
    /**
     * @stability stable
     */
    get upgradeDomainTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set upgradeDomainTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpgradeDomainTimeout(): void;
    /**
     * @stability stable
     */
    get upgradeDomainTimeoutInput(): string | undefined;
    private _upgradeReplicaSetCheckTimeout?;
    /**
     * @stability stable
     */
    get upgradeReplicaSetCheckTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set upgradeReplicaSetCheckTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpgradeReplicaSetCheckTimeout(): void;
    /**
     * @stability stable
     */
    get upgradeReplicaSetCheckTimeoutInput(): string | undefined;
    private _upgradeTimeout?;
    /**
     * @stability stable
     */
    get upgradeTimeout(): string | undefined;
    /**
     * @stability stable
     */
    set upgradeTimeout(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpgradeTimeout(): void;
    /**
     * @stability stable
     */
    get upgradeTimeoutInput(): string | undefined;
    private _deltaHealthPolicy?;
    private __deltaHealthPolicyOutput;
    /**
     * @stability stable
     */
    get deltaHealthPolicy(): ServiceFabricClusterUpgradePolicyDeltaHealthPolicyOutputReference;
    /**
     * @stability stable
     */
    putDeltaHealthPolicy(value: ServiceFabricClusterUpgradePolicyDeltaHealthPolicy | undefined): void;
    /**
     * @stability stable
     */
    resetDeltaHealthPolicy(): void;
    /**
     * @stability stable
     */
    get deltaHealthPolicyInput(): ServiceFabricClusterUpgradePolicyDeltaHealthPolicy | undefined;
    private _healthPolicy?;
    private __healthPolicyOutput;
    /**
     * @stability stable
     */
    get healthPolicy(): ServiceFabricClusterUpgradePolicyHealthPolicyOutputReference;
    /**
     * @stability stable
     */
    putHealthPolicy(value: ServiceFabricClusterUpgradePolicyHealthPolicy | undefined): void;
    /**
     * @stability stable
     */
    resetHealthPolicy(): void;
    /**
     * @stability stable
     */
    get healthPolicyInput(): ServiceFabricClusterUpgradePolicyHealthPolicy | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html azurerm_service_fabric_cluster}.
 *
 * @stability stable
 */
export declare class ServiceFabricCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/service_fabric_cluster.html azurerm_service_fabric_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceFabricClusterConfig);
    private _addOnFeatures?;
    /**
     * @stability stable
     */
    get addOnFeatures(): string[] | undefined;
    /**
     * @stability stable
     */
    set addOnFeatures(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetAddOnFeatures(): void;
    /**
     * @stability stable
     */
    get addOnFeaturesInput(): string[] | undefined;
    private _clusterCodeVersion?;
    /**
     * @stability stable
     */
    get clusterCodeVersion(): string | undefined;
    /**
     * @stability stable
     */
    set clusterCodeVersion(value: string | undefined);
    /**
     * @stability stable
     */
    resetClusterCodeVersion(): void;
    /**
     * @stability stable
     */
    get clusterCodeVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get clusterEndpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _managementEndpoint?;
    /**
     * @stability stable
     */
    get managementEndpoint(): string;
    /**
     * @stability stable
     */
    set managementEndpoint(value: string);
    /**
     * @stability stable
     */
    get managementEndpointInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _reliabilityLevel?;
    /**
     * @stability stable
     */
    get reliabilityLevel(): string;
    /**
     * @stability stable
     */
    set reliabilityLevel(value: string);
    /**
     * @stability stable
     */
    get reliabilityLevelInput(): string | undefined;
    private _resourceGroupName?;
    /**
     * @stability stable
     */
    get resourceGroupName(): string;
    /**
     * @stability stable
     */
    set resourceGroupName(value: string);
    /**
     * @stability stable
     */
    get resourceGroupNameInput(): string | undefined;
    private _serviceFabricZonalUpgradeMode?;
    /**
     * @stability stable
     */
    get serviceFabricZonalUpgradeMode(): string | undefined;
    /**
     * @stability stable
     */
    set serviceFabricZonalUpgradeMode(value: string | undefined);
    /**
     * @stability stable
     */
    resetServiceFabricZonalUpgradeMode(): void;
    /**
     * @stability stable
     */
    get serviceFabricZonalUpgradeModeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable | undefined);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _upgradeMode?;
    /**
     * @stability stable
     */
    get upgradeMode(): string;
    /**
     * @stability stable
     */
    set upgradeMode(value: string);
    /**
     * @stability stable
     */
    get upgradeModeInput(): string | undefined;
    private _vmImage?;
    /**
     * @stability stable
     */
    get vmImage(): string;
    /**
     * @stability stable
     */
    set vmImage(value: string);
    /**
     * @stability stable
     */
    get vmImageInput(): string | undefined;
    private _vmssZonalUpgradeMode?;
    /**
     * @stability stable
     */
    get vmssZonalUpgradeMode(): string | undefined;
    /**
     * @stability stable
     */
    set vmssZonalUpgradeMode(value: string | undefined);
    /**
     * @stability stable
     */
    resetVmssZonalUpgradeMode(): void;
    /**
     * @stability stable
     */
    get vmssZonalUpgradeModeInput(): string | undefined;
    private _azureActiveDirectory?;
    private __azureActiveDirectoryOutput;
    /**
     * @stability stable
     */
    get azureActiveDirectory(): ServiceFabricClusterAzureActiveDirectoryOutputReference;
    /**
     * @stability stable
     */
    putAzureActiveDirectory(value: ServiceFabricClusterAzureActiveDirectory | undefined): void;
    /**
     * @stability stable
     */
    resetAzureActiveDirectory(): void;
    /**
     * @stability stable
     */
    get azureActiveDirectoryInput(): ServiceFabricClusterAzureActiveDirectory | undefined;
    private _certificate?;
    private __certificateOutput;
    /**
     * @stability stable
     */
    get certificate(): ServiceFabricClusterCertificateOutputReference;
    /**
     * @stability stable
     */
    putCertificate(value: ServiceFabricClusterCertificate | undefined): void;
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): ServiceFabricClusterCertificate | undefined;
    private _certificateCommonNames?;
    private __certificateCommonNamesOutput;
    /**
     * @stability stable
     */
    get certificateCommonNames(): ServiceFabricClusterCertificateCommonNamesOutputReference;
    /**
     * @stability stable
     */
    putCertificateCommonNames(value: ServiceFabricClusterCertificateCommonNames | undefined): void;
    /**
     * @stability stable
     */
    resetCertificateCommonNames(): void;
    /**
     * @stability stable
     */
    get certificateCommonNamesInput(): ServiceFabricClusterCertificateCommonNames | undefined;
    private _clientCertificateCommonName?;
    /**
     * @stability stable
     */
    get clientCertificateCommonName(): ServiceFabricClusterClientCertificateCommonName[] | undefined;
    /**
     * @stability stable
     */
    set clientCertificateCommonName(value: ServiceFabricClusterClientCertificateCommonName[] | undefined);
    /**
     * @stability stable
     */
    resetClientCertificateCommonName(): void;
    /**
     * @stability stable
     */
    get clientCertificateCommonNameInput(): ServiceFabricClusterClientCertificateCommonName[] | undefined;
    private _clientCertificateThumbprint?;
    /**
     * @stability stable
     */
    get clientCertificateThumbprint(): ServiceFabricClusterClientCertificateThumbprint[] | undefined;
    /**
     * @stability stable
     */
    set clientCertificateThumbprint(value: ServiceFabricClusterClientCertificateThumbprint[] | undefined);
    /**
     * @stability stable
     */
    resetClientCertificateThumbprint(): void;
    /**
     * @stability stable
     */
    get clientCertificateThumbprintInput(): ServiceFabricClusterClientCertificateThumbprint[] | undefined;
    private _diagnosticsConfig?;
    private __diagnosticsConfigOutput;
    /**
     * @stability stable
     */
    get diagnosticsConfig(): ServiceFabricClusterDiagnosticsConfigOutputReference;
    /**
     * @stability stable
     */
    putDiagnosticsConfig(value: ServiceFabricClusterDiagnosticsConfig | undefined): void;
    /**
     * @stability stable
     */
    resetDiagnosticsConfig(): void;
    /**
     * @stability stable
     */
    get diagnosticsConfigInput(): ServiceFabricClusterDiagnosticsConfig | undefined;
    private _fabricSettings?;
    /**
     * @stability stable
     */
    get fabricSettings(): ServiceFabricClusterFabricSettings[] | undefined;
    /**
     * @stability stable
     */
    set fabricSettings(value: ServiceFabricClusterFabricSettings[] | undefined);
    /**
     * @stability stable
     */
    resetFabricSettings(): void;
    /**
     * @stability stable
     */
    get fabricSettingsInput(): ServiceFabricClusterFabricSettings[] | undefined;
    private _nodeType?;
    /**
     * @stability stable
     */
    get nodeType(): ServiceFabricClusterNodeType[];
    /**
     * @stability stable
     */
    set nodeType(value: ServiceFabricClusterNodeType[]);
    /**
     * @stability stable
     */
    get nodeTypeInput(): ServiceFabricClusterNodeType[] | undefined;
    private _reverseProxyCertificate?;
    private __reverseProxyCertificateOutput;
    /**
     * @stability stable
     */
    get reverseProxyCertificate(): ServiceFabricClusterReverseProxyCertificateOutputReference;
    /**
     * @stability stable
     */
    putReverseProxyCertificate(value: ServiceFabricClusterReverseProxyCertificate | undefined): void;
    /**
     * @stability stable
     */
    resetReverseProxyCertificate(): void;
    /**
     * @stability stable
     */
    get reverseProxyCertificateInput(): ServiceFabricClusterReverseProxyCertificate | undefined;
    private _reverseProxyCertificateCommonNames?;
    private __reverseProxyCertificateCommonNamesOutput;
    /**
     * @stability stable
     */
    get reverseProxyCertificateCommonNames(): ServiceFabricClusterReverseProxyCertificateCommonNamesOutputReference;
    /**
     * @stability stable
     */
    putReverseProxyCertificateCommonNames(value: ServiceFabricClusterReverseProxyCertificateCommonNames | undefined): void;
    /**
     * @stability stable
     */
    resetReverseProxyCertificateCommonNames(): void;
    /**
     * @stability stable
     */
    get reverseProxyCertificateCommonNamesInput(): ServiceFabricClusterReverseProxyCertificateCommonNames | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): ServiceFabricClusterTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ServiceFabricClusterTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ServiceFabricClusterTimeouts | undefined;
    private _upgradePolicy?;
    private __upgradePolicyOutput;
    /**
     * @stability stable
     */
    get upgradePolicy(): ServiceFabricClusterUpgradePolicyOutputReference;
    /**
     * @stability stable
     */
    putUpgradePolicy(value: ServiceFabricClusterUpgradePolicy | undefined): void;
    /**
     * @stability stable
     */
    resetUpgradePolicy(): void;
    /**
     * @stability stable
     */
    get upgradePolicyInput(): ServiceFabricClusterUpgradePolicy | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
