import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StorageManagementPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#storage_account_id StorageManagementPolicy#storage_account_id}.
     *
     * @stability stable
     */
    readonly storageAccountId: string;
    /**
     * rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#rule StorageManagementPolicy#rule}
     *
     * @stability stable
     */
    readonly rule?: StorageManagementPolicyRule[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#timeouts StorageManagementPolicy#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StorageManagementPolicyTimeouts;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsBaseBlob {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_modification_greater_than StorageManagementPolicy#delete_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceModificationGreaterThan?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#tier_to_archive_after_days_since_modification_greater_than StorageManagementPolicy#tier_to_archive_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly tierToArchiveAfterDaysSinceModificationGreaterThan?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#tier_to_cool_after_days_since_modification_greater_than StorageManagementPolicy#tier_to_cool_after_days_since_modification_greater_than}.
     *
     * @stability stable
     */
    readonly tierToCoolAfterDaysSinceModificationGreaterThan?: number;
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyRuleActionsBaseBlobOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _deleteAfterDaysSinceModificationGreaterThan?;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceModificationGreaterThan(): number | undefined;
    /**
     * @stability stable
     */
    set deleteAfterDaysSinceModificationGreaterThan(value: number | undefined);
    /**
     * @stability stable
     */
    resetDeleteAfterDaysSinceModificationGreaterThan(): void;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceModificationGreaterThanInput(): number | undefined;
    private _tierToArchiveAfterDaysSinceModificationGreaterThan?;
    /**
     * @stability stable
     */
    get tierToArchiveAfterDaysSinceModificationGreaterThan(): number | undefined;
    /**
     * @stability stable
     */
    set tierToArchiveAfterDaysSinceModificationGreaterThan(value: number | undefined);
    /**
     * @stability stable
     */
    resetTierToArchiveAfterDaysSinceModificationGreaterThan(): void;
    /**
     * @stability stable
     */
    get tierToArchiveAfterDaysSinceModificationGreaterThanInput(): number | undefined;
    private _tierToCoolAfterDaysSinceModificationGreaterThan?;
    /**
     * @stability stable
     */
    get tierToCoolAfterDaysSinceModificationGreaterThan(): number | undefined;
    /**
     * @stability stable
     */
    set tierToCoolAfterDaysSinceModificationGreaterThan(value: number | undefined);
    /**
     * @stability stable
     */
    resetTierToCoolAfterDaysSinceModificationGreaterThan(): void;
    /**
     * @stability stable
     */
    get tierToCoolAfterDaysSinceModificationGreaterThanInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsSnapshot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_archive_after_days_since_creation StorageManagementPolicy#change_tier_to_archive_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToArchiveAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_cool_after_days_since_creation StorageManagementPolicy#change_tier_to_cool_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToCoolAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_creation_greater_than StorageManagementPolicy#delete_after_days_since_creation_greater_than}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceCreationGreaterThan?: number;
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyRuleActionsSnapshotOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _changeTierToArchiveAfterDaysSinceCreation?;
    /**
     * @stability stable
     */
    get changeTierToArchiveAfterDaysSinceCreation(): number | undefined;
    /**
     * @stability stable
     */
    set changeTierToArchiveAfterDaysSinceCreation(value: number | undefined);
    /**
     * @stability stable
     */
    resetChangeTierToArchiveAfterDaysSinceCreation(): void;
    /**
     * @stability stable
     */
    get changeTierToArchiveAfterDaysSinceCreationInput(): number | undefined;
    private _changeTierToCoolAfterDaysSinceCreation?;
    /**
     * @stability stable
     */
    get changeTierToCoolAfterDaysSinceCreation(): number | undefined;
    /**
     * @stability stable
     */
    set changeTierToCoolAfterDaysSinceCreation(value: number | undefined);
    /**
     * @stability stable
     */
    resetChangeTierToCoolAfterDaysSinceCreation(): void;
    /**
     * @stability stable
     */
    get changeTierToCoolAfterDaysSinceCreationInput(): number | undefined;
    private _deleteAfterDaysSinceCreationGreaterThan?;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceCreationGreaterThan(): number | undefined;
    /**
     * @stability stable
     */
    set deleteAfterDaysSinceCreationGreaterThan(value: number | undefined);
    /**
     * @stability stable
     */
    resetDeleteAfterDaysSinceCreationGreaterThan(): void;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceCreationGreaterThanInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActionsVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_archive_after_days_since_creation StorageManagementPolicy#change_tier_to_archive_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToArchiveAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#change_tier_to_cool_after_days_since_creation StorageManagementPolicy#change_tier_to_cool_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly changeTierToCoolAfterDaysSinceCreation?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete_after_days_since_creation StorageManagementPolicy#delete_after_days_since_creation}.
     *
     * @stability stable
     */
    readonly deleteAfterDaysSinceCreation?: number;
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyRuleActionsVersionOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _changeTierToArchiveAfterDaysSinceCreation?;
    /**
     * @stability stable
     */
    get changeTierToArchiveAfterDaysSinceCreation(): number | undefined;
    /**
     * @stability stable
     */
    set changeTierToArchiveAfterDaysSinceCreation(value: number | undefined);
    /**
     * @stability stable
     */
    resetChangeTierToArchiveAfterDaysSinceCreation(): void;
    /**
     * @stability stable
     */
    get changeTierToArchiveAfterDaysSinceCreationInput(): number | undefined;
    private _changeTierToCoolAfterDaysSinceCreation?;
    /**
     * @stability stable
     */
    get changeTierToCoolAfterDaysSinceCreation(): number | undefined;
    /**
     * @stability stable
     */
    set changeTierToCoolAfterDaysSinceCreation(value: number | undefined);
    /**
     * @stability stable
     */
    resetChangeTierToCoolAfterDaysSinceCreation(): void;
    /**
     * @stability stable
     */
    get changeTierToCoolAfterDaysSinceCreationInput(): number | undefined;
    private _deleteAfterDaysSinceCreation?;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceCreation(): number | undefined;
    /**
     * @stability stable
     */
    set deleteAfterDaysSinceCreation(value: number | undefined);
    /**
     * @stability stable
     */
    resetDeleteAfterDaysSinceCreation(): void;
    /**
     * @stability stable
     */
    get deleteAfterDaysSinceCreationInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleActions {
    /**
     * base_blob block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#base_blob StorageManagementPolicy#base_blob}
     *
     * @stability stable
     */
    readonly baseBlob?: StorageManagementPolicyRuleActionsBaseBlob;
    /**
     * snapshot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#snapshot StorageManagementPolicy#snapshot}
     *
     * @stability stable
     */
    readonly snapshot?: StorageManagementPolicyRuleActionsSnapshot;
    /**
     * version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#version StorageManagementPolicy#version}
     *
     * @stability stable
     */
    readonly version?: StorageManagementPolicyRuleActionsVersion;
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyRuleActionsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _baseBlob?;
    private __baseBlobOutput;
    /**
     * @stability stable
     */
    get baseBlob(): StorageManagementPolicyRuleActionsBaseBlobOutputReference;
    /**
     * @stability stable
     */
    putBaseBlob(value: StorageManagementPolicyRuleActionsBaseBlob | undefined): void;
    /**
     * @stability stable
     */
    resetBaseBlob(): void;
    /**
     * @stability stable
     */
    get baseBlobInput(): StorageManagementPolicyRuleActionsBaseBlob | undefined;
    private _snapshot?;
    private __snapshotOutput;
    /**
     * @stability stable
     */
    get snapshot(): StorageManagementPolicyRuleActionsSnapshotOutputReference;
    /**
     * @stability stable
     */
    putSnapshot(value: StorageManagementPolicyRuleActionsSnapshot | undefined): void;
    /**
     * @stability stable
     */
    resetSnapshot(): void;
    /**
     * @stability stable
     */
    get snapshotInput(): StorageManagementPolicyRuleActionsSnapshot | undefined;
    private _version?;
    private __versionOutput;
    /**
     * @stability stable
     */
    get version(): StorageManagementPolicyRuleActionsVersionOutputReference;
    /**
     * @stability stable
     */
    putVersion(value: StorageManagementPolicyRuleActionsVersion | undefined): void;
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): StorageManagementPolicyRuleActionsVersion | undefined;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleFiltersMatchBlobIndexTag {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#name StorageManagementPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#operation StorageManagementPolicy#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#value StorageManagementPolicy#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRuleFilters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#blob_types StorageManagementPolicy#blob_types}.
     *
     * @stability stable
     */
    readonly blobTypes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#prefix_match StorageManagementPolicy#prefix_match}.
     *
     * @stability stable
     */
    readonly prefixMatch?: string[];
    /**
     * match_blob_index_tag block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#match_blob_index_tag StorageManagementPolicy#match_blob_index_tag}
     *
     * @stability stable
     */
    readonly matchBlobIndexTag?: StorageManagementPolicyRuleFiltersMatchBlobIndexTag[];
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyRuleFiltersOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _blobTypes?;
    /**
     * @stability stable
     */
    get blobTypes(): string[] | undefined;
    /**
     * @stability stable
     */
    set blobTypes(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetBlobTypes(): void;
    /**
     * @stability stable
     */
    get blobTypesInput(): string[] | undefined;
    private _prefixMatch?;
    /**
     * @stability stable
     */
    get prefixMatch(): string[] | undefined;
    /**
     * @stability stable
     */
    set prefixMatch(value: string[] | undefined);
    /**
     * @stability stable
     */
    resetPrefixMatch(): void;
    /**
     * @stability stable
     */
    get prefixMatchInput(): string[] | undefined;
    private _matchBlobIndexTag?;
    /**
     * @stability stable
     */
    get matchBlobIndexTag(): StorageManagementPolicyRuleFiltersMatchBlobIndexTag[] | undefined;
    /**
     * @stability stable
     */
    set matchBlobIndexTag(value: StorageManagementPolicyRuleFiltersMatchBlobIndexTag[] | undefined);
    /**
     * @stability stable
     */
    resetMatchBlobIndexTag(): void;
    /**
     * @stability stable
     */
    get matchBlobIndexTagInput(): StorageManagementPolicyRuleFiltersMatchBlobIndexTag[] | undefined;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#enabled StorageManagementPolicy#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#name StorageManagementPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * actions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#actions StorageManagementPolicy#actions}
     *
     * @stability stable
     */
    readonly actions: StorageManagementPolicyRuleActions;
    /**
     * filters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#filters StorageManagementPolicy#filters}
     *
     * @stability stable
     */
    readonly filters?: StorageManagementPolicyRuleFilters;
}
/**
 * @stability stable
 */
export interface StorageManagementPolicyTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#create StorageManagementPolicy#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#delete StorageManagementPolicy#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#read StorageManagementPolicy#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html#update StorageManagementPolicy#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class StorageManagementPolicyTimeoutsOutputReference extends cdktf.ComplexObject {
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string | undefined;
    /**
     * @stability stable
     */
    set create(value: string | undefined);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string | undefined;
    /**
     * @stability stable
     */
    set delete(value: string | undefined);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _read?;
    /**
     * @stability stable
     */
    get read(): string | undefined;
    /**
     * @stability stable
     */
    set read(value: string | undefined);
    /**
     * @stability stable
     */
    resetRead(): void;
    /**
     * @stability stable
     */
    get readInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string | undefined;
    /**
     * @stability stable
     */
    set update(value: string | undefined);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html azurerm_storage_management_policy}.
 *
 * @stability stable
 */
export declare class StorageManagementPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azurerm/r/storage_management_policy.html azurerm_storage_management_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StorageManagementPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _storageAccountId?;
    /**
     * @stability stable
     */
    get storageAccountId(): string;
    /**
     * @stability stable
     */
    set storageAccountId(value: string);
    /**
     * @stability stable
     */
    get storageAccountIdInput(): string | undefined;
    private _rule?;
    /**
     * @stability stable
     */
    get rule(): StorageManagementPolicyRule[] | undefined;
    /**
     * @stability stable
     */
    set rule(value: StorageManagementPolicyRule[] | undefined);
    /**
     * @stability stable
     */
    resetRule(): void;
    /**
     * @stability stable
     */
    get ruleInput(): StorageManagementPolicyRule[] | undefined;
    private _timeouts?;
    private __timeoutsOutput;
    /**
     * @stability stable
     */
    get timeouts(): StorageManagementPolicyTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: StorageManagementPolicyTimeouts | undefined): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StorageManagementPolicyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
